#include <cstdio>
#include <iostream>
#include <algorithm>
#include <vector>
#include "testlib.h"

using namespace std;

int ja[3];
int pa[3];

vector<int> inv;

int sumSq(int * ar) {
	return (ar[0] - ar[1]) * (ar[0] - ar[1]) + (ar[0] - ar[2]) * (ar[0] - ar[2]) + (ar[2] - ar[1]) * (ar[2] - ar[1]);
}

void scanIn() {
	int n = inf.readInt();
	for (int i = 0; i < n; i++) {
		int v = inf.readInt();
		inv.push_back(v);
	}
}

bool notIn(int v) {
	for (size_t i = 0; i < inv.size(); i++) {
		if (v == inv[i]) {
			return true;
		}
	}
	return false;
}

int main(int argc, char * argv[]) {

	registerTestlibCmd(argc, argv);
	
	for (int i = 0; i < 3; i++) {
		pa[i] = ouf.readInt();
		ja[i] = ans.readInt();
	}
	
	int a = sumSq(ja);
	int b = sumSq(pa);
	
	if (a != b) {
		quitf(_wa, "expected % d, found % d", a, b);
	}
	
	scanIn();
	
	for (int i = 0; i < 3; i++) {
		if (pa[i] != ja[i]) {
			if (notIn(pa[i])) {
				quitf(_wa, "not valid number % d", pa[i]);
			}
		}
	}
	
	quitf(_ok, "answer is %d", a);

	return 0;

} 
