#include <cstdio>
#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

struct step {
	
	int t, num;
	bool arrive;
	
	step(int t, int num, bool arrive) : t(t), num(num), arrive(arrive) {};
	
};

vector<step> v;

int main() {

	int n, m, k;
	scanf("%d %d %d\n", &n, &m, &k);
	for (int i = 0; i < m; i++) {
		int hours, mins, num;
		char c;
		scanf("%d:%d %d %c\n", &hours, &mins, &num, &c);
		v.push_back(step(hours * 60 + mins, num, c == '+'));
	}
	for (int i = 0; i < k; i++) {
		int hours, mins, num;
		scanf("%d:%d %d\n", &hours, &mins, &num);
		int t = hours * 60 + mins;
		int cnt = 0;
		for (size_t j = 0; j < v.size(); j++) {
			if (v[j].num == num && v[j].t <= t) {
				if (v[j].arrive) {
					cnt++;
				} else {
					cnt--;
				}
			}
		}
		printf("%d\n", cnt);
	}

	return 0;

} 
