#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include "testlib.h"

using namespace std;

vector<int> a;
int aircount[1005];
int airtime[10000][1005];

void printtime(int hours, int mins) {
	if (hours < 10) {
		cout << "0";
	}
	cout << hours << ":";
	if (mins < 10) {
		cout << "0";
	}
	cout << mins;
}

int main(int argc, char * argv[]) {
	
	
	registerGen(argc, argv);
	int n = atoi(argv[1]);
	int m = atoi(argv[2]);
	int k = atoi(argv[3]);
	
	
	cout << n << " " << m << " " << k << endl;
	for (int i = 1; i < n; i++) {
		aircount[i] = rnd.next(101);
		airtime[0][i] = aircount[i];
		cout << aircount[i] << " ";
	}
	aircount[n] = rnd.next(101);
	airtime[0][n] = aircount[n];
	cout << aircount[n] << endl;
	int all = 0;
	for (int hours = 0; hours < 24; hours++) {
		for (int mins = 0; mins < 60; mins++) {
			int cnt = rnd.next(m >= 24*60 ? m / (24*60) + 2 : 3);
			cnt = min(m - all, cnt);
			for (int i = 0; i < cnt; i++) {
				int air = rnd.next(n) + 1;
				int coin;
				if (!aircount[air]) {
					coin = 1;
				} else {
					coin = rnd.next(2);
				}
				printtime(hours, mins);
				cout << " " << air << " " << (coin ? "+" : "-") << endl;
				aircount[air] += (coin ? 1 : -1);
			}
			all += cnt;
			for (int i = 1; i <= n; i++) {
				airtime[hours * 60 + mins][i] = aircount[i];
			}
		}
	}
	for (int i = 0; i < k; i++) {
		int hours = rnd.next(24);
		int mins = rnd.next(60);
		int coin;
		bool f = false;
		while (!f) {
			int p = rnd.next(n) + 1;
			if (airtime[hours * 60 + mins][p] > 2) {
				coin = rnd.next(10);
				if (coin) {
					f = true;
					printtime(hours, mins);
					cout << " " << p << endl;
				}
			} else {
				coin = rnd.next(10);
				if (!coin) {
					f = true;
					printtime(hours, mins);
					cout << " " << p << endl;
				}
			}
		}
		
	}
	
	
	
	return 0;
}
